// Program to generate random instances for problem Physical Music
// Author: Rudy van Vliet
// Date: 30 September, 2015

#include <iostream>
#include <cstdlib>
using namespace std;

const int MaxN = 1000000;
int posInDTN[MaxN+1];  // posInDTN[i]: position in Download Top N of single
                       //   ranked i in Single Top N

//****************************************************************************

int GenerateRandomNumber (int Min, int Max)
 // generate a random number between Min en Max (inclusive)
{ int r,
      Range;
  double fr;

  r = rand ();
  Range = Max - Min + 1;
  fr = ((double) r)/(((double) RAND_MAX)+1.0);
    // with just `RAND_MAX + 1' one might exceed MAXINT
    // and thus get a negative number
  fr *= Range;

  return (Min + (int) fr);

}  // GenerateRandomNumber

//****************************************************************************

int main ()
{ int NInst, Inst;
  int minValue, maxValue,
      N,
      i,
      j, p;

  cin >> NInst;
  cout << NInst << endl;

  for (Inst=1;Inst<=NInst;Inst++)
  { 
    cin >> minValue >> maxValue;
    N = GenerateRandomNumber (minValue, maxValue);
    cout << N << endl;

      // initialize array
    for (i=1;i<=N;i++)
      posInDTN[i] = i;

    for (j=N;j>=1;j--)
    { p = GenerateRandomNumber (1,j);
      cout << posInDTN[p] << endl;
      posInDTN[p] = posInDTN[j];
    }

  }  // for Inst
  
  return 0;

}
