import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;


public class SolutionJan {
	
	private static int MODULO = 5318008;
	
	private static BufferedReader br;
	private static BufferedWriter bw;
	
	public static void main(String[] args) throws IOException {
		br = new BufferedReader(new InputStreamReader(System.in));
		bw = new BufferedWriter(new OutputStreamWriter(System.out));
		
		int T = Integer.parseInt(br.readLine());
		
		for (int i = 0; i < T; ++i) {
			int N = Integer.parseInt(br.readLine());
			
			String[] parts = br.readLine().split(" ");
			
			solve(N, Integer.parseInt(parts[0])-1, 
				  Integer.parseInt(parts[1])-1, Integer.parseInt(parts[2])-1, 
				  Integer.parseInt(parts[3])-1);
		}
		br.close();
		bw.close();
	}
	
	private static void solve(int N, int startX, int startY, int targetX, int targetY) throws IOException {
		
		
		int diffX = Math.abs(startX - targetX);
		int diffY = Math.abs(startY - targetY);
		
		if (diffX == diffY) {
			bw.write("1\n");
		} else if (diffX > diffY) {
			solve(N, startY, startX, targetY, targetX);
			
		} else if (startY > targetY) {
			solve(N, targetX, targetY, startX, startY);
			
		} else { // diffY > diffX, targetY > startY
			int[] memOld = new int[N];
			int[] memNew = new int[N];
			
			memNew[startX] = 1;
			
			for (int i = 1; i <= diffY; ++i) {
				
				memOld = Arrays.copyOf(memNew, memNew.length);
				
				for (int j = -1 * i; j <= i; ++j) {
					int currX = startX + j;
					if (currX >= 0 && currX < N) {
						int total = memOld[currX];
						
						if (currX - 1 >= 0) total += memOld[currX-1];
						if (currX + 1  < N) total += memOld[currX+1];
						
						memNew[currX] = total % MODULO;
					}
				}
			}
			bw.write(memNew[targetX]+"\n");
		}
	}
}
