#include <cmath>
#include <iostream>

using namespace std;

void extended_euclidean(long A, long B, long* gcd, long* R, long* S)
{
	// Assume A > B
	long first = A;
	long second = B;
	long first_times_A = 1;
	long first_times_B = 0;
	long second_times_A = 0;
	long second_times_B = 1;
	
	while ((first % second) != 0)
	{
		long times = first / second;
		long new_second = first - second * times;
		long new_second_times_A = first_times_A - times * second_times_A;
		long new_second_times_B = first_times_B - times * second_times_B;
		first = second;
		first_times_A = second_times_A;
		first_times_B = second_times_B;
		second = new_second;
		second_times_A = new_second_times_A;
		second_times_B = new_second_times_B;
	}
	*gcd = second;
	*R = second_times_A;
	*S = second_times_B;
}

int main(int argc, char** argv)
{
	int T;
	cin >> T;
	while (T > 0)
	{
		T--;
		long R, S, Q;
		
		cin >> R >> S >> Q;
		
		long gcd;
		long A_prime;
		long B_prime;
		extended_euclidean(R, -S, &gcd, &A_prime, &B_prime);

		B_prime = -B_prime;

		long A = A_prime * Q / gcd;
		long B = B_prime * Q / gcd;
		long A_increaser = -S / gcd;
		long B_increaser = R / gcd;

		while (A <= 0) { A += A_increaser; B += B_increaser; }
		while (B <= 0) { A += A_increaser; B += B_increaser; }
		
		while ((B - B_increaser > 0) && (A - A_increaser > 0))
		{
			A -= A_increaser;
			B -= B_increaser;
		}
			
		cout << A << " " << B << endl;
	}
		
	return 0;
}
