import java.io.*;
import java.util.*;

public class boaz_godzilla {
	public final int MIN_L = 3;
	public final int MIN_W = 3;
	public final int MAX_L = 1000;
	public final int MAX_W = 1000;
	public final int MAX_MECH = 100;
	public final char CHAR_MECH = 'M';
	public final char CHAR_GODZILLA = 'G';
	public final char CHAR_STREET = '.';
	public final char CHAR_RESIDENTIAL = 'R';

	static BufferedReader in = new BufferedReader(new InputStreamReader(System.in));

	//public boaz_godzilla() {}
	public static void main(String[] args) throws Exception {
		new boaz_godzilla().doProblem();
	}

	public void doProblem() throws Exception {
		String testcases = in.readLine();
		int cases = Integer.parseInt(testcases);

		while (cases-- > 0) solve();
	}

	private int l, w;
	private char[][] map;
	private Queue<xy> flood;
	private xy godzilla;
	private int round;
	private int residentialSectorsDestroyed;
	private int[] dx = { 0, 1, 0, -1 };
	private int[] dy = { -1, 0, 1, 0 };
	private int[] gdx = { 0, 1, 0, -1 };
	private int[] gdy = { -1, 0, 1, 0 };
	public void solve() throws Exception {
		String input = in.readLine();
		String[] dim = input.split(" ");
		l = Integer.parseInt(dim[0]);
		w = Integer.parseInt(dim[1]);

		map = new char[MAX_W][];
		flood = new LinkedList<xy>();

		for (int _y = 0; _y < w; _y++) {
			String line = in.readLine();
			map[_y] = new char[MAX_L];
			for (int i = 0; i < line.length(); i++) {
				map[_y][i] = line.charAt(i);
				switch (map[_y][i]) {
					case CHAR_GODZILLA:
						godzilla = new xy(i, _y);
						map[_y][i] = '#';
						break;
					case CHAR_MECH:
						flood.add(new xy(i, _y));
						map[_y][i] = '*';
						break;
				}
			}
		}

		residentialSectorsDestroyed = 0;

		while (true) {
			doGodzillaTurn();
			doMechTurn();
			if (godzillaInRange()) break;
		}
		System.out.println(residentialSectorsDestroyed);
	}

	private void doMechTurn() {
		Queue<xy> newQ = new LinkedList<xy>();
		while (flood.size() > 0) {
			xy s = flood.remove();
			boolean pathObstructed = false;
			for (int j = 0; j < 4; j++) {
				int x = s.x + dx[j];
				if (x < 0 || x >= l) continue;
				int y = s.y + dy[j];
				if (y < 0 || y >= w) continue;

				if (map[y][x] == CHAR_STREET || map[y][x] == '#') {
					newQ.add(new xy(x, y));
					map[y][x] = '*';
				}
				else if (!pathObstructed && map[y][x] == CHAR_RESIDENTIAL)
					pathObstructed = true;
			}
			if (pathObstructed)
				newQ.add(s);
		}
		flood = newQ;
	}

	private boolean godzillaInRange() {
		xy s = new xy(godzilla.x, godzilla.y);
		while (--s.x >= 0 && map[s.y][s.x] != CHAR_RESIDENTIAL) if (map[s.y][s.x] == '*') return true;
		s.x = godzilla.x;
		while (++s.x < l && map[s.y][s.x] != CHAR_RESIDENTIAL) if (map[s.y][s.x] == '*') return true;
		s.x = godzilla.x;
		while (--s.y >= 0 && map[s.y][s.x] != CHAR_RESIDENTIAL) if (map[s.y][s.x] == '*') return true;
		s.y = godzilla.y;
		while (++s.y < w && map[s.y][s.x] != CHAR_RESIDENTIAL) if (map[s.y][s.x] == '*') return true;

		return false;
	}

	private void doGodzillaTurn() {
		for (int j = 0; j < 4; j++) {
			int x = godzilla.x + gdx[j];
			if (x < 0 || x >= l) continue;
			int y = godzilla.y + gdy[j];
			if (y < 0 || y >= w) continue;

			if (map[y][x] == CHAR_RESIDENTIAL) {
				godzilla.x = x;
				godzilla.y = y;
				map[godzilla.y][godzilla.x] = '#';
				++residentialSectorsDestroyed;
				return;
			}
		}

		for (int j = 0; j < 4; j++) {
			int x = godzilla.x + gdx[j];
			if (x < 0 || x >= l) continue;
			int y = godzilla.y + gdy[j];
			if (y < 0 || y >= w) continue;

			if (map[y][x] == CHAR_STREET) {
				godzilla.x = x;
				godzilla.y = y;
				map[godzilla.y][godzilla.x] = '#';
				return;
			}
		}
	}

	private class xy {
		public int x, y;
		public xy(int _x, int _y) {
			x = _x;
			y = _y;
		}
	}
}
