import java.io.*;
import java.util.*;

public class boaz_museum {
	static BufferedReader in = new BufferedReader(new InputStreamReader(System.in));

	public boaz_museum() {}

	public static void main(String[] args) throws Exception {
		new boaz_museum().doProblem();
	}

	public void doProblem() throws Exception {
		String testcases = in.readLine();
		int cases = Integer.parseInt(testcases);

		while (cases-- > 0) solve();
	}

	private int l, w;
	private double x, y, sw;
	private line[] pedestal;
	private int gn;
	public void solve() throws Exception {
		String input = in.readLine();
		String[] dim = input.split(" ");
		l = Integer.parseInt(dim[0]);
		w = Integer.parseInt(dim[1]);

		input = in.readLine();
		String[] ped = input.split(" ");

		x = Double.parseDouble(ped[0]);
		y = Double.parseDouble(ped[1]);
		sw = Double.parseDouble(ped[2]);

		pedestal = new line[4];
		pedestal[0] = new line(x, y, x + sw, y); // Top
		pedestal[1] = new line(x + sw, y, x + sw, y + sw); // Right
		pedestal[2] = new line(x, y + sw, x + sw, y + sw); // Bottom
		pedestal[3] = new line(x, y, x, y + sw); // Left
		gn = 0;

		ArrayList<point> pillars = new ArrayList<point>();

		for (int i = 0; i <= l; i++)
			pillars.add(new point(i, 0, gn++));

		for (int i = 1; i <= w; i++)
			pillars.add(new point(l, i, gn++));

		for (int i = 0; i <= l - 1; i++)
			pillars.add(new point(i, w, gn++));

		for (int i = 1; i <= w - 1; i++)
			pillars.add(new point(0, i, gn++));

		int count = 0;
		for (int i = 0; i < pillars.size(); i++) {
			point p1 = pillars.get(i);
			for (int j = i + 1; j < pillars.size(); j++) {
				point p2 = pillars.get(j);
				
				if (p1.x != p2.x || p1.y != p2.y) {
					line l = new line(p1.x, p1.y, p2.x, p2.y);
					if (intersectsPedestal(l)) continue;
				}

				for (int k = j + 1; k < pillars.size(); k++) {
					point p3 = pillars.get(k);
					if (p1.x == p2.x && p2.x == p3.x) continue;
					if (p1.y == p2.y && p2.y == p3.y) continue;

					if (p1.x != p3.x || p1.y != p3.y) {
						line l = new line(p1.x, p1.y, p3.x, p3.y);
						if (intersectsPedestal(l)) continue;
					}

					if (p2.x != p3.x || p2.y != p3.y) {
						line l = new line(p2.x, p2.y, p3.x, p3.y);
						if (intersectsPedestal(l)) continue;
					}

					++count;
				}
			}
		}
		System.out.println(count);
	}

	private boolean intersectsPedestal(line l) {
		return intersects(l, pedestal[0]) || intersects(l, pedestal[1]) || intersects(l, pedestal[2]) || intersects(l, pedestal[3]);
	}

	private boolean intersects(line l1, line l2) {
		double d = (l2.y2 - l2.y1) * (l1.x2 - l1.x1) - (l2.x2 - l2.x1) * (l1.y2 - l1.y1);
		double n_a = (l2.x2 - l2.x1) * (l1.y1 - l2.y1) - (l2.y2 - l2.y1) * (l1.x1 - l2.x1);
		double n_b = (l1.x2 - l1.x1) * (l1.y1 - l2.y1) - (l1.y2 - l1.y1) * (l1.x1 - l2.x1);

		if (Math.abs(d) <= 0.0001d)
			return false;

		double ua = n_a / d;
		double ub = n_b / d;

		if (ua >= 0d && ua <= 1d && ub >= 0d && ub <= 1d) return true;
		return false;
	}

	public class line {
		public double x1, y1, x2, y2;
		public line(double x1, double y1, double x2, double y2) { this.x1 = x1; this.y1 = y1; this.x2 = x2; this.y2 = y2; }
	}

	public class point {
		public int x, y, n;
		public point(int _x, int _y, int _n) { x = _x; y = _y; n = _n; }
	}

}
