// @author Frank
// $opgave Godzilla

#include <cstring>
#include <iostream>
#include <vector>
using namespace std;

/*
. non-residental
R residental
D destroyed
G godzilla (1) start
M mech start

*/

struct coord {
	int i, j;
};

char board[1002][1002];
bool godvisited[1002][1002];
bool mechpos[1002][1002];
int w, l, eaten;
coord godzilla, temp;
vector<coord> mechfront;

void print() {
	for(int i=0; i<=w; i++) {
		for(int j=0; j<=l; j++) {		
			if(i == godzilla.i && j == godzilla.j)
				cerr << 'G';
			else if(mechpos[i][j])
				cerr << 'M';						
			else
				cerr << board[i][j];
		}
		cerr << endl;
	} 
	cerr << endl;
} // print board for debugging

bool finished() {
	int i, j;
	i = godzilla.i;
	j = godzilla.j;
	while(mechpos[i][j] != true && (board[i][j] == 'D' || board[i][j] == '.') && i <= w) {
		i++;
	}
	if(mechpos[i][j])
		return true;
	i = godzilla.i;
	j = godzilla.j;
	while(mechpos[i][j] != true && (board[i][j] == 'D' || board[i][j] == '.') && i > 0) {
		i--;
	}
	if(mechpos[i][j])
		return true;	
	i = godzilla.i;
	j = godzilla.j;
	while(mechpos[i][j] != true && (board[i][j] == 'D' || board[i][j] == '.') && j <= l) {
		j++;
	}
	if(mechpos[i][j])
		return true;
	i = godzilla.i;
	j = godzilla.j;
	while(mechpos[i][j] != true && (board[i][j] == 'D' || board[i][j] == '.') && j > 0) {
		j--;
	}
	if(mechpos[i][j])
		return true;				
	return false;
}

bool movegodzilla() {
	if(!godvisited[godzilla.i-1][godzilla.j] && board[godzilla.i-1][godzilla.j] == 'R') {
		godzilla.i = godzilla.i-1;
		board[godzilla.i][godzilla.j] = 'D';		
		eaten++;
	}
	else if(!godvisited[godzilla.i][godzilla.j+1] && board[godzilla.i][godzilla.j+1] == 'R') {
		godzilla.j = godzilla.j+1;
		board[godzilla.i][godzilla.j] = 'D';		
		eaten++;		
	}	
	else if(!godvisited[godzilla.i+1][godzilla.j] && board[godzilla.i+1][godzilla.j] == 'R') {
		godzilla.i = godzilla.i+1;
		board[godzilla.i][godzilla.j] = 'D';	
		eaten++;			
	}
	else if(!godvisited[godzilla.i][godzilla.j-1] && board[godzilla.i][godzilla.j-1] == 'R') {
		godzilla.j = godzilla.j-1;
		board[godzilla.i][godzilla.j] = 'D';
		eaten++;				
	}		
	else if(!godvisited[godzilla.i-1][godzilla.j] && board[godzilla.i-1][godzilla.j] == '.') {
		godzilla.i = godzilla.i-1;
	}
	else if(!godvisited[godzilla.i][godzilla.j+1] && board[godzilla.i][godzilla.j+1] == '.') {
		godzilla.j = godzilla.j+1;
	}	
	else if(!godvisited[godzilla.i+1][godzilla.j] && board[godzilla.i+1][godzilla.j] == '.') {
		godzilla.i = godzilla.i+1;
	}
	else if(!godvisited[godzilla.i][godzilla.j-1] && board[godzilla.i][godzilla.j-1] == '.') {
		godzilla.j = godzilla.j-1;
	}		
	else {
		return false; // did not move
	}
	godvisited[godzilla.i][godzilla.j] = true;
	return true; // moved
}

void movemechfront() { 		// look in all 4 directions and flood-like add mechs where possible
	vector<coord> newmechfront;
	int z = mechfront.size();
	for(int m=0; m<z; m++) {
		coord currentmech = mechfront[m];
		if(!mechpos[currentmech.i-1][currentmech.j] && (board[currentmech.i-1][currentmech.j] == '.' || board[currentmech.i-1][currentmech.j] == 'D') && currentmech.i-1 > 0) {
			temp.i = currentmech.i-1;
			temp.j = currentmech.j;			
			mechpos[temp.i][temp.j] = true;	
			newmechfront.push_back(temp);
		}	
		if(!mechpos[currentmech.i+1][currentmech.j] && (board[currentmech.i+1][currentmech.j] == '.' || board[currentmech.i+1][currentmech.j] == 'D') && currentmech.i+1 <= w) {
			temp.i = currentmech.i+1;
			temp.j = currentmech.j;			
			mechpos[temp.i][temp.j] = true;	
			newmechfront.push_back(temp);
		}	
		if(!mechpos[currentmech.i][currentmech.j-1] && (board[currentmech.i][currentmech.j-1] == '.' || board[currentmech.i][currentmech.j-1] == 'D') && currentmech.j-1 > 0) {
			temp.i = currentmech.i;
			temp.j = currentmech.j-1;			
			mechpos[temp.i][temp.j] = true;	
			newmechfront.push_back(temp);
		}	
		if(!mechpos[currentmech.i][currentmech.j+1] && (board[currentmech.i][currentmech.j+1] == '.' || board[currentmech.i][currentmech.j+1] == 'D' )&& currentmech.j+1 <= l) {
			temp.i = currentmech.i;
			temp.j = currentmech.j+1;			
			mechpos[temp.i][temp.j] = true;	
			newmechfront.push_back(temp);
		}					
	}
	mechfront.clear();
	mechfront = newmechfront;
}

int main() {
	int round;
	int T;

	cin >> T;
	
	while(T) {
		cin >> l >> w;
		memset(board, 0, sizeof(board));		
		memset(godvisited, 0, sizeof(godvisited));				
		memset(mechpos, 0, sizeof(mechpos));						
		mechfront.clear();
		eaten = 0;
		
		for(int i=1; i<=w; i++) {
			for(int j=1; j<=l; j++) {		
				cin >> board[i][j];
				if(board[i][j] == 'G') {
					godzilla.i = i;
					godzilla.j = j;
					board[i][j] = '.';
					godvisited[i][j] = true;
				}
				else if(board[i][j] == 'M') {
					temp.i = i;
					temp.j = j;			
					mechfront.push_back(temp);
					board[i][j] = '.';
					mechpos[i][j] = true;					
				}
			}
		} 
		
		round = 0;
		//print();		
		do {
			round++;
			movegodzilla();
			movemechfront();
			//print();					
		} while(!finished());
		cout << eaten << endl;
                T--;
	} // while
} // main
