#include <cstring>
#include <iostream>
#include <map>
#include <queue>
#include <vector>
using namespace std;

map <string, int> nodeMap;
int n;
const int N = 10000;
vector<int> edges[N+1];
int d[N+1];

void addEdge(string s, string t) {
	if(!nodeMap[s])
		nodeMap[s] = ++n;
	if(!nodeMap[t])
		nodeMap[t] = ++n;
	int i = nodeMap[s];
	int j = nodeMap[t];
	edges[i].push_back(j);
	edges[j].push_back(i);	
} // addEdge

int eccentricity(int current) {
	//clog << current << "\t";
	int ecc = -1;
	memset(d, -1, sizeof(d));
	d[current] = 0;
	queue<int> q;
	q.push(current);
	while(!q.empty()) {
		current = q.front();
		q.pop();
		for(int i=0; i<(signed)edges[current].size(); i++)
			if(d[edges[current][i]] == -1) {
				d[edges[current][i]] = d[current] + 1;
				q.push(edges[current][i]);
				ecc = max(ecc, d[edges[current][i]]); // edges[current][i]] also has eccentricity at least ecc, set this already to prune a bit
			} // if
	} // while
	//clog << ecc << endl;
	return ecc;
} // eccentricity

void go() {
	int count = 0.0;
	for(int i=1; i<=n; i++)
		if(eccentricity(i) > 6) 
			count++;
	//clog << ((double)count / (double) n) << endl;
	if(((double)count / (double) n) > 0.05000000)
		cout << "NO" << endl;
	else			
		cout << "YES" << endl;	
} // go

int main() {
	int T, m;
	string s, t;
	cin >> T;
	while(T--) {
		cin >> m;
		n = 0;
		for(int i=0; i<N+1; i++)
			edges[i].clear();
		nodeMap.clear();
		while(m--) {
			cin >> s >> t;
			addEdge(s, t);
		} // while
		go();
	} // while
	return 0;
} // main
