#include <iostream>
#include <cassert>

using namespace std;

struct uggd_t {
	long long r, s, t;
	friend istream& operator>>(istream& is, uggd_t& u) {
		is >> u.r >> u.s >> u.t;
		return is;
	}
	friend ostream& operator<<(ostream& os, const uggd_t& u) {
		os << "r = " << u.r << ", s = " << u.s << ", t = " << u.t;
		return os;
	}
	bool operator==(const uggd_t& other) const {
		return r == other.r && s == other.s && t == other.t;
	}
	bool operator!=(const uggd_t& other) const {
		return !(*this == other);
	}
};

template<class T>
T abs(T a) {
	if (a < 0) return -a;
	return a;
}

uggd_t uggd(long long a, long long b) {
	long long x, lastx, y, lasty;
	long long q;

	x = lasty = 0;
	y = lastx = 1;

	while (b != 0) {
		q = a / b;

		a %= b;
		swap(a,b);

		lastx -= q*x;
		swap(x, lastx);

		lasty -= q*y;
		swap(y, lasty);
	}

	return (uggd_t) {lastx, lasty, a};
}

void solve() {
	uggd_t u;
	cin >> u;
	assert(u.t > 0);
	assert(u.r > 0 || u.s > 0);
	assert(u.r <= 0 || u.s <= 0);
	bool verwisseld = false;
	if (u.r <= 0) {
		swap(u.r, u.s);
		verwisseld = true;
	}
	long long r = abs(u.r);
	long long s = abs(u.s);
	long long t = abs(u.t);
	uggd_t v = uggd(r, s);
	long long g = v.t;
	assert(r % g == 0);
	assert(s % g == 0);
	assert(t % g == 0);
	long long incA = s / g;
	long long incB = r / g;
	long long a = v.r;
	long long b = v.s;
	assert(a * r + b * s == g);
	b *= -1;
	if (verwisseld) {
		swap(u.r, u.s);
		swap(a, b);
		swap(v.r, v.s);
		swap(incA, incB);
		swap(r, s);
	}
	assert(a * u.r + b * u.s == g);
	while (a > 0 && b > 0) {
		a -= incA;
		b -= incB;
	}
	while (a <= 0 || b <= 0) {
		a += incA;
		b += incB;
	}
	assert(a * u.r + b * u.s == g);
	assert(a > 0 && b > 0);
	// nu corrigeren door vermenigvuldigen met t / g
	a *= t / g;
	b *= t / g;
	assert(a * u.r + b * u.s == u.t);
	while (a > 0 && b > 0) {
		a -= incA;
		b -= incB;
	}
	while (a <= 0 || b <= 0) {
		a += incA;
		b += incB;
	}
	assert(a * u.r + b * u.s == u.t);
	assert(a > 0 && b > 0);
	cout << a << " " << b << endl;
}

int main() {
	int T;
	cin >> T;
	for (int i = 0; i < T; i++)
		solve();
	return 0;
}
