#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <cctype>
#include <climits>
#include <cassert>

#include <vector>
#include <deque>
#include <queue>
#include <stack>
#include <list>
#include <set>
#include <map>
#include <string>

#include <iostream>
#include <sstream>

#include <utility>
#include <functional>
#include <limits>
#include <numeric>
#include <algorithm> 

using namespace std;

int L, W;
double X, Y, Ws;
bool conn[433][433];

struct vect { double x, y; vect (double _x, double _y) : x(_x), y(_y) { } };

struct punt {
	double x, y; string naam;
	punt (double _x, double _y, string _n) : x(_x), y(_y), naam(_n) { }
	punt () { x = 0.0; y = 0.0; naam = "niets"; }
};

vect operator- (punt p, punt q) { return vect (q.x-p.x, q.y-p.y); }

double cross(vect u, vect v) { return u.x*v.y - u.y*v.x; }

int sgn(double i) { return (i > 0) ? 1 : ((i < 0) ? -1 : 0); }

int direction (punt a, punt b, punt c) { return sgn (cross(b-a,c-a)); }

bool onSegment(punt a, punt b, punt c) {
	return (min(a.x, b.x) <= c.x && max(a.x, b.x) >= c.x && min(a.y, b.y) <= c.y && max(a.y, b.y) >= c.y);
}

bool segIntersect (punt p1, punt p2, punt p3, punt p4) {
	int d1 = direction(p3,p4,p1);
	int d2 = direction(p3,p4,p2);
	int d3 = direction(p1,p2,p3);
	int d4 = direction(p1,p2,p4);
	if (d1*d2 < 0 && d3*d4 < 0) return true;
	if (d1 == 0 && onSegment(p3,p4,p1)) return true;
	if (d2 == 0 && onSegment(p3,p4,p2)) return true;
	if (d3 == 0 && onSegment(p1,p2,p3)) return true;
	if (d4 == 0 && onSegment(p1,p2,p4)) return true;
	return false;
}

punt P[433];
punt LB, LO, RB, RO;
int aP;

void doit() {
	aP = 0;
	cin >> L >> W >> X >> Y >> Ws;
	LO = punt(X,Y,"doos");
	LB = punt(X,Y+Ws,"doos");
	RO = punt(X+Ws,Y,"doos");
	RB = punt(X+Ws,Y+Ws,"doos");
	//cerr << "Doos: (" << X << "," << Y << ") tot (" << X+Ws << "," << Y+Ws << ")\n"; 
	for (int i = 0; i <= W; i++) {
		P[aP] = punt(0,i,"pannenkoek"); aP++;
		//cerr << "Added " << aP-1 << ": (" << 0 << "," << i << ")\n";
		P[aP] = punt(L,i,"pannenkoek"); aP++;
		//cerr << "Added " << aP-1 << ": (" << L << "," << i << ")\n";
	}
	for (int j = 1; j < L; j++) {
		P[aP] = punt(j,0,"pannenkoek"); aP++;
		//cerr << "Added " << aP-1 << ": (" << j << "," << 0 << ")\n";
		P[aP] = punt(j,W,"pannenkoek"); aP++;
		//cerr << "Added " << aP-1 << ": (" << j << "," << W << ")\n";
	}
	for (int i = 0; i < aP; i++) {
		for (int j = 0; j < aP; j++) {
			if (i == j)
				conn[i][j] = false;
			else
				conn[i][j] = !(segIntersect(LO,RB,P[i],P[j]) || segIntersect(RO,LB,P[i],P[j]));
			//if ((i == 4) && (j == 6))
				//cerr << segIntersect(LO,RB,P[i],P[j]) << " and " << segIntersect(RO,LB,P[i],P[j]) << "\n";
			//cerr << conn[i][j];
		}
		//cerr << "\n";
	}
	long long sol = - W*(W+1)*(W-1)/3 - L*(L+1)*(L-1)/3;
	for (int i = 0; i < aP; i++)
	for (int j = i+1; j < aP; j++)
	for (int k = j+1; k < aP; k++) {
		if (conn[i][j] && conn[j][k] && conn[i][k])
			sol++;
	}
	cout << sol << "\n";
}

int main () {
	int T;
	cin >> T;
	for (int t = 1; t <= T; t++) {
		doit();
	}
	return 0;
}
