// floodfill approach
// slow, memory quadratic: this should be to slow

#include <cstdio>
#include <cstdlib>

#include <algorithm>
#include <queue>
#include <set>
#include <utility>

int const N = 5000;
int const MAGIC = 5318008;

int count[N][N];

int do_it(int const                              n,
          std::pair<int const, int const> const &start,
          std::pair<int const, int const> const &dest)
{
  for (int i = 0; i < n; ++i)
  {
    for (int j = 0; j < n; ++j)
    {
      count[i][j] = 0;
    } // for
  } // for

  std::queue<std::pair<int const, int const> > todo;
  std::set<std::pair<int const, int const> > queued;

  todo.push(start);
  queued.insert(start);
  while (!todo.empty())
  {
    std::pair<int const, int const> const here = todo.front();
    todo.pop();

    int const dist = std::max(abs(here.first - start.first), abs(here.second - start.second));
    int sum = 0;
    for (int x = -1; x <= 1; ++x)
    {
      for (int y = -1; y <= 1; ++y)
      {
        std::pair<int const, int const> const next(here.first + x, here.second + y);

        if (next.first >= 0 && next.first < n &&
            next.second >= 0 && next.second < n)
        {
          if (std::max(abs(next.first - start.first), abs(next.second - start.second)) < dist)
          {
            sum += count[next.first][next.second];
          } // if
          else if (queued.count(next) != 1)
          {
            todo.push(next);
            queued.insert(next);
          } // if
        } // if
      } // for
    } // for

    if (dist == 0)
    {
      count[here.first][here.second] = 1;
    } // if
    else
    {
      count[here.first][here.second] = sum % MAGIC;
    } // else
  } // while

/*
  count[start.first][start.second] = 0;
  for (int x = n - 1; x >= 0; --x)
  {
    for (int y = 0; y < n; ++y)
    {
      fprintf(stderr, "%4d ", count[y][x]);
    } // for
    fprintf(stderr, "\n");
  } // for
*/

  return count[dest.first][dest.second];
} // do_it

int main(int, char* [])
{
  int T;
  if (scanf("%d\n", &T) != 1 || T <= 0)
  {
    fprintf(stderr, "Input format error\n");
    return 1;
  } // if

  for (int t = 0; t < T; ++t)
  {
    int n;
    int x1;
    int y1;
    int x2;
    int y2;
    if (scanf("%d\n%d %d %d %d\n", &n, &x1, &y1, &x2, &y2) != 5 ||
        n < 2 || n > N ||
        x1 <= 0 || x1 > N ||
        y1 <= 0 || y1 > N ||
        x2 <= 0 || x2 > N ||
        y2 <= 0 || y2 > N ||
        (x1 == x2 && y1 == y2))
    {
      fprintf(stderr, "Input error case: %d\n", t + 1);
      return 1;
    } // if

    printf("%d\n", do_it(n, std::pair<int const, int const>(x1 - 1, y1 - 1), std::pair<int const, int const>(x2 - 1, y2 - 1)));
  } // for

  return 0;
} // main

